scalaVersion := "2.12.3"

libraryDependencies += "org.scalatest" % "scalatest_2.12" % "3.0.1" % "test"

scalaSource in Compile := baseDirectory.value / "src"

scalaSource in Test := baseDirectory.value / "test" / "src"

artifactName in (Compile, packageSrc) := { (sv: ScalaVersion, module: ModuleID, artifact: Artifact) =>
    "for-marmoset.zip"
}

mappings in (Compile, packageSrc) := {
          (sources in Compile).value pair rebase(baseDirectory.value / "src", "src/")
}

mappings in (Compile, packageSrc) ++= {
          ((baseDirectory.value / "test") ** "*") pair rebase(baseDirectory.value / "test", "test/")
}
